
#include "config.h"

#if STATIC_SCRIPTS

#include "static_scripts.h"

/* testscript */
static const uint8_t testscript_flash1[] PROGMEM = {
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),

    MACRO_WAIT(_BV(CHANNEL_RED)),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 235),
    MACRO_WAIT(_BV(CHANNEL_RED)),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_JUMP(-4),
    MACRO_STOP()
    };

static const uint8_t testscript_flash2[] PROGMEM = {
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),

    MACRO_FADE_CHANNEL(CHANNEL_RED, 0, 0x100),
    MACRO_WAIT(_BV(CHANNEL_RED)),
    MACRO_FADE_CHANNEL(CHANNEL_RED, 155, 0x100),
    MACRO_WAIT(_BV(CHANNEL_RED)),
    MACRO_JUMP(-4),
    };


static const uint8_t testscript_eeprom[] EEMEM = {
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),

    MACRO_FADE_CHANNEL(CHANNEL_GREEN, 135, 0xf00),
    MACRO_WAIT(_BV(CHANNEL_GREEN)),
    MACRO_FADE_CHANNEL(CHANNEL_GREEN, 0, 0x100),
    MACRO_WAIT(_BV(CHANNEL_GREEN)),
    MACRO_JUMP(-4)
    };


static const uint8_t colorchange_red[] PROGMEM = {
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),

    MACRO_FADE_CHANNEL(CHANNEL_RED, 235, 0x200),

    MACRO_WAIT(_BV(CHANNEL_RED)|_BV(CHANNEL_GREEN)|_BV(CHANNEL_BLUE)|_BV(CHANNEL_WHITE)),
    MACRO_FADE_CHANNEL(CHANNEL_RED, 0, 0x040),
    MACRO_FADE_CHANNEL(CHANNEL_GREEN, 235, 0x040),
    MACRO_WAIT(_BV(CHANNEL_RED)|_BV(CHANNEL_GREEN)|_BV(CHANNEL_BLUE)|_BV(CHANNEL_WHITE)),
    MACRO_FADE_CHANNEL(CHANNEL_GREEN, 0, 0x040),
    MACRO_FADE_CHANNEL(CHANNEL_BLUE, 235, 0x040),
    MACRO_WAIT(_BV(CHANNEL_RED)|_BV(CHANNEL_GREEN)|_BV(CHANNEL_BLUE)|_BV(CHANNEL_WHITE)),
    MACRO_FADE_CHANNEL(CHANNEL_BLUE, 0, 0x040),
    MACRO_FADE_CHANNEL(CHANNEL_WHITE, 235, 0x040),
    MACRO_WAIT(_BV(CHANNEL_RED)|_BV(CHANNEL_GREEN)|_BV(CHANNEL_BLUE)|_BV(CHANNEL_WHITE)),
    MACRO_FADE_CHANNEL(CHANNEL_WHITE, 0, 0x040),
    MACRO_FADE_CHANNEL(CHANNEL_RED, 235, 0x040),
    MACRO_JUMP(-12)
    };

static const uint8_t colorchange_red_blue[] PROGMEM = {
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),

    MACRO_FADE_CHANNEL(CHANNEL_RED, 235, 0x200),

    MACRO_WAIT(_BV(CHANNEL_RED)|_BV(CHANNEL_BLUE)),
    MACRO_FADE_CHANNEL(CHANNEL_RED, 0, 0x040),
    MACRO_FADE_CHANNEL(CHANNEL_BLUE, 235, 0x040),
    MACRO_WAIT(_BV(CHANNEL_RED)|_BV(CHANNEL_BLUE)),
    MACRO_FADE_CHANNEL(CHANNEL_BLUE, 0, 0x040),
    MACRO_FADE_CHANNEL(CHANNEL_RED, 235, 0x040),
    MACRO_JUMP(-6)
    };


static const uint8_t green_flash[] PROGMEM = {
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),

    MACRO_FADE_CHANNEL(CHANNEL_GREEN, 235, 0xf00),
    MACRO_WAIT(_BV(CHANNEL_GREEN)),
    MACRO_FADE_CHANNEL(CHANNEL_GREEN, 0, 0x100),
    MACRO_WAIT(_BV(CHANNEL_GREEN)),
    MACRO_STOP()
    };

static const uint8_t green_blink[] PROGMEM = {
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),

    MACRO_SET_CHANNEL(CHANNEL_GREEN, 235),
    MACRO_SLEEP(125),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 55),
    MACRO_SLEEP(125),
    MACRO_JUMP(-4)
    };

static const uint8_t blinken[] PROGMEM = {
    MACRO_SET_CHANNEL(CHANNEL_RED, 235),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),
    MACRO_SLEEP(125),
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 235),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),
    MACRO_SLEEP(125),
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 235),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),
    MACRO_SLEEP(125),
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 235),
    MACRO_SLEEP(125),
    MACRO_SET_CHANNEL(CHANNEL_RED, 128),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),
    MACRO_SLEEP(125),
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 128),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),
    MACRO_SLEEP(125),
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 128),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),
    MACRO_SLEEP(125),
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 128),
    MACRO_SLEEP(125),
    MACRO_JUMP(-40)
    };

static const uint8_t faden[] PROGMEM = {
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),
    MACRO_SLEEP(125),

    MACRO_FADE_CHANNEL(CHANNEL_RED, 235, 0x200),
    MACRO_WAIT(_BV(CHANNEL_RED)),
    MACRO_SLEEP(75),
    MACRO_FADE_CHANNEL(CHANNEL_RED, 0, 0x200),
    MACRO_WAIT(_BV(CHANNEL_RED)),
    MACRO_SLEEP(75),
    MACRO_FADE_CHANNEL(CHANNEL_GREEN, 235, 0x200),
    MACRO_WAIT(_BV(CHANNEL_GREEN)),
    MACRO_SLEEP(75),
    MACRO_FADE_CHANNEL(CHANNEL_GREEN, 0, 0x200),
    MACRO_WAIT(_BV(CHANNEL_GREEN)),
    MACRO_SLEEP(75),
    MACRO_FADE_CHANNEL(CHANNEL_BLUE, 235, 0x200),
    MACRO_WAIT(_BV(CHANNEL_BLUE)),
    MACRO_SLEEP(75),
    MACRO_FADE_CHANNEL(CHANNEL_BLUE, 0, 0x200),
    MACRO_WAIT(_BV(CHANNEL_BLUE)),
    MACRO_SLEEP(75),
    MACRO_FADE_CHANNEL(CHANNEL_WHITE, 235, 0x200),
    MACRO_WAIT(_BV(CHANNEL_WHITE)),
    MACRO_SLEEP(75),
    MACRO_FADE_CHANNEL(CHANNEL_WHITE, 0, 0x200),
    MACRO_WAIT(_BV(CHANNEL_WHITE)),
    MACRO_SLEEP(75),
    MACRO_JUMP(-24)
    };

static const uint8_t langsam_blinken[] PROGMEM = {
    MACRO_SET_CHANNEL(CHANNEL_RED, 235),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),
    MACRO_SLEEP(255),
    MACRO_SLEEP(255),
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 235),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),
    MACRO_SLEEP(255),
    MACRO_SLEEP(255),
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 235),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 0),
    MACRO_SLEEP(255),
    MACRO_SLEEP(255),
    MACRO_SET_CHANNEL(CHANNEL_RED, 0),
    MACRO_SET_CHANNEL(CHANNEL_GREEN, 0),
    MACRO_SET_CHANNEL(CHANNEL_BLUE, 0),
    MACRO_SET_CHANNEL(CHANNEL_WHITE, 235),
    MACRO_SLEEP(255),
    MACRO_SLEEP(255),
    MACRO_JUMP(-24)
    };

#endif
